ATF-TEST-PROGRAM(1)

NAME
atf-test-program - common interface to ATF test programs

SYNOPSIS
atf-test-program [-r resfile] [-s srcdir] [-v var1=value1 [.. -v varN=valueN]] test_case
atf-test-program -l

DESCRIPTION
Test programs written using the ATF libraries all share a common user interface, which is what this manual page describes. NOTE: There is no binary known as atf-test-program; what is described in this manual page is the command-line interface exposed by the atf-c, atf-c++ and atf-sh bindings.

In the first synopsis form, the test program will execute the provided test case and print its results to the standard output, unless otherwise stated by the -r flag. Optionally, the test case name can be suffixed by ‘:cleanup’, in which case the cleanup routine of the test case will be executed instead of the test case body; see atf-test-case(4). Note that the test case is executed without isolation, so it can and probably will create and modify files in the current directory. To execute test cases in a controller manner, refer to atf-run(1), which is the preferred way to run test cases. You should only execute test cases by hand for debugging purposes.

In the second synopsis form, the test program will list all available test cases alongside their meta-data properties in a format that is machine parseable. This list is processed by atf-run(1) to know how to execute the test cases of a given test program.

The following options are available:

-l  Lists available test cases alongside a brief description for each of them.

-r resfile
    Specifies the file that will receive the test case result. If not specified, the test case prints its results to stdout. If the result of a test case needs to be parsed by another program, you must use this option to redirect the result to a file and then read the resulting file from the other program. Note: do not try to process the stdout of the test case because your program may break in the future.

-s srcdir
    The path to the directory where the test program is located. This is needed in all cases, except when the test program is being executed from the current directory. The test program will use this path to locate any helper data files or utilities.

-v var=value
    Sets the configuration variable var to the value value.

SEE ALSO
atf-run(1), atf(7)